__all__ = ["Info"]

import subprocess
import re
from collections import namedtuple
class Info:
    def __init__(self):
        """nvidia_smi가 없으면 에러
        """
        nvidia_smi = subprocess.check_output('nvidia-smi', shell=True)
        if not nvidia_smi:
            raise Exception('nvidia-smi command not found')
        self.raw_str = nvidia_smi.decode('utf-8')
        self.memory:list = self.get_memory_info()

    def __repr__(self):
        return self.raw_str

    def get_memory_info(self)->list:
        GPU_MEM = namedtuple('GPU_MEM', "num used size")
        rex = re.compile(r'(\d+MiB)\s+/\s+(\d+MiB)')
        mat = rex.findall(self.raw_str)
        gpu_list =  [GPU_MEM(num, gpu_mem[0][:-3], gpu_mem[1][:-3]) for num, gpu_mem in enumerate(mat)]
        self.memory = gpu_list
        return gpu_list

    def gpu_process_info(self):
        pass
