import time
import os

from functools import wraps, lru_cache
from typing import Dict, List, Tuple, Any


def get_time(func):
    @wraps(func)
    def function(*args, **kwargs):
        now = time.time()
        result = func(*args, **kwargs)
        print(f"load time {func.__name__}: {time.time() - now}")
        return result
    return function