__all__ = ['video_maker']


import cv2
from PIL import Image
import numpy as np
import glob
import os
import subprocess
import logging


"ffmpeg -i not_medi_005.mp4 -vf scale=320:180 -c:v libx264 -preset fast -c:a aac output.mp4 -hide_banner"
logger = logging.getLogger("medication.image_to_video")


def video_maker(video_name, img_array, format='mp4v'):
    """param
    video_name: str
    img_array: images"""
    if not os.path.isdir(os.path.dirname(video_name)):
        os.makedirs(os.path.dirname(video_name))
    out = cv2.VideoWriter(
        f"{os.path.splitext(video_name)[0]}.mp4",
        cv2.VideoWriter_fourcc(*"mp4v"),
        20,
        img_array[0].size,
    )
    for i in img_array:
        b, g, r = i.split()
        i = Image.merge("RGB", (r, g, b))
        out.write(np.asarray(i))
    out.release()
    if format != 'mp4v':
        if os.path.isfile(f"{os.path.splitext(video_name)[0]}_h264.mp4"):
            os.remove(f"{os.path.splitext(video_name)[0]}_h264.mp4")
        subprocess.run(
            f"ffmpeg -i {os.path.splitext(video_name)[0]}.mp4 \
            -vf scale=1280:720 -c:v libx264 -preset fast -c:a aac \
                {os.path.splitext(video_name)[0]}_h264.mp4 -hide_banner",
            shell=True,
        )
    return [f"{os.path.splitext(video_name)[0]}.mp4",]