import os
import math


from medi.object_list import object_list
from django.conf import settings

from .prediction import prediction_short, prediction_long
from .video_to_csv import get_prediction


def save_csv(feature_flag, file):
    for i in range(len(feature_flag) - 1):
        print(feature_flag[i], file=file, end=',')
    else:
        print(feature_flag[-1], file=file)


def train_csv_long(detection_result, degree, key, video_name):
    long_feature = prediction_long(detection_result, degree)

    with open(f"medi{degree}_long.csv", "a") as f:
        long_feature.append(key)
        save_csv(long_feature, f)
    with open(f"medi{degree}_name.csv", "a") as f:
        print(video_name, file=f)

    return long_feature


def train_csv_short(detection_result, degree, key, video_name):
    with open(f"medi{degree}_short.csv", "a") as f:
        feature_list = prediction_short(detection_result, degree)
        feature_list.append(key)
        save_csv(feature_list, f)
    return feature_list
